/*
 * Blockdaemon REST API
 *
 * Blockdaemon REST API provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple protocols/cryptocurrencies.  [Documentation](https://docs.blockdaemon.com/reference/rest-api-overview)  ### Currently supported protocols:  * algorand   * mainnet * avalanche    * mainnet-c/testnet-c * bitcoin   * mainnet/testnet * bitcoincash   * mainnet/testnet * dogecoin   * mainnet/testnet * ethereum   * mainnet/holesky/sepolia * fantom   * mainnet/testnet * litecoin   * mainnet/testnet * near   * mainnet * optimism   * mainnet * polkadot   * mainnet/westend * polygon   * mainnet/amoy * solana   * mainnet/testnet * stellar   * mainnet/testnet * tezos   * mainnet * tron   * mainnet/nile * xrp   * mainnet  ### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.
 *
 * API version: 3.0.0
 * Contact: support@blockdaemon.com
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package ubiquity

import (
	"encoding/json"
)

// Tx struct for Tx
type Tx struct {
	// Unique transaction identifier.
	Id *string `json:"id,omitempty"`
	// Block hash if mined, otherwise omitted.
	BlockId NullableString `json:"block_id,omitempty"`
	// The transaction creation unix timestamp.
	Date *int64 `json:"date,omitempty"`
	// Result status of the transaction.
	Status *string `json:"status,omitempty"`
	// List of transaction events.
	NumEvents *int32 `json:"num_events,omitempty"`
	// Protocol specific data that doesn't fit into a standard model.
	Meta *map[string]interface{} `json:"meta,omitempty"`
	// Block number if mined, otherwise omitted.
	BlockNumber NullableInt32 `json:"block_number,omitempty"`
	// Total transaction confirmations.
	Confirmations *int32  `json:"confirmations,omitempty"`
	Events        []Event `json:"events,omitempty"`
	// List of moved assets by asset path. Find all the asset paths on this [page](https://docs.blockdaemon.com/reference/available-currencies-and-tokens).
	Assets []string `json:"assets,omitempty"`
	// The nonce of the transaction.
	Nonce *int32 `json:"nonce,omitempty"`
}

// NewTx instantiates a new Tx object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTx() *Tx {
	this := Tx{}
	return &this
}

// NewTxWithDefaults instantiates a new Tx object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTxWithDefaults() *Tx {
	this := Tx{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *Tx) GetId() string {
	if o == nil || o.Id == nil {
		var ret string
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Tx) GetIdOk() (*string, bool) {
	if o == nil || o.Id == nil {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *Tx) HasId() bool {
	if o != nil && o.Id != nil {
		return true
	}

	return false
}

// SetId gets a reference to the given string and assigns it to the Id field.
func (o *Tx) SetId(v string) {
	o.Id = &v
}

// GetBlockId returns the BlockId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Tx) GetBlockId() string {
	if o == nil || o.BlockId.Get() == nil {
		var ret string
		return ret
	}
	return *o.BlockId.Get()
}

// GetBlockIdOk returns a tuple with the BlockId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Tx) GetBlockIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.BlockId.Get(), o.BlockId.IsSet()
}

// HasBlockId returns a boolean if a field has been set.
func (o *Tx) HasBlockId() bool {
	if o != nil && o.BlockId.IsSet() {
		return true
	}

	return false
}

// SetBlockId gets a reference to the given NullableString and assigns it to the BlockId field.
func (o *Tx) SetBlockId(v string) {
	o.BlockId.Set(&v)
}

// SetBlockIdNil sets the value for BlockId to be an explicit nil
func (o *Tx) SetBlockIdNil() {
	o.BlockId.Set(nil)
}

// UnsetBlockId ensures that no value is present for BlockId, not even an explicit nil
func (o *Tx) UnsetBlockId() {
	o.BlockId.Unset()
}

// GetDate returns the Date field value if set, zero value otherwise.
func (o *Tx) GetDate() int64 {
	if o == nil || o.Date == nil {
		var ret int64
		return ret
	}
	return *o.Date
}

// GetDateOk returns a tuple with the Date field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Tx) GetDateOk() (*int64, bool) {
	if o == nil || o.Date == nil {
		return nil, false
	}
	return o.Date, true
}

// HasDate returns a boolean if a field has been set.
func (o *Tx) HasDate() bool {
	if o != nil && o.Date != nil {
		return true
	}

	return false
}

// SetDate gets a reference to the given int64 and assigns it to the Date field.
func (o *Tx) SetDate(v int64) {
	o.Date = &v
}

// GetStatus returns the Status field value if set, zero value otherwise.
func (o *Tx) GetStatus() string {
	if o == nil || o.Status == nil {
		var ret string
		return ret
	}
	return *o.Status
}

// GetStatusOk returns a tuple with the Status field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Tx) GetStatusOk() (*string, bool) {
	if o == nil || o.Status == nil {
		return nil, false
	}
	return o.Status, true
}

// HasStatus returns a boolean if a field has been set.
func (o *Tx) HasStatus() bool {
	if o != nil && o.Status != nil {
		return true
	}

	return false
}

// SetStatus gets a reference to the given string and assigns it to the Status field.
func (o *Tx) SetStatus(v string) {
	o.Status = &v
}

// GetNumEvents returns the NumEvents field value if set, zero value otherwise.
func (o *Tx) GetNumEvents() int32 {
	if o == nil || o.NumEvents == nil {
		var ret int32
		return ret
	}
	return *o.NumEvents
}

// GetNumEventsOk returns a tuple with the NumEvents field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Tx) GetNumEventsOk() (*int32, bool) {
	if o == nil || o.NumEvents == nil {
		return nil, false
	}
	return o.NumEvents, true
}

// HasNumEvents returns a boolean if a field has been set.
func (o *Tx) HasNumEvents() bool {
	if o != nil && o.NumEvents != nil {
		return true
	}

	return false
}

// SetNumEvents gets a reference to the given int32 and assigns it to the NumEvents field.
func (o *Tx) SetNumEvents(v int32) {
	o.NumEvents = &v
}

// GetMeta returns the Meta field value if set, zero value otherwise.
func (o *Tx) GetMeta() map[string]interface{} {
	if o == nil || o.Meta == nil {
		var ret map[string]interface{}
		return ret
	}
	return *o.Meta
}

// GetMetaOk returns a tuple with the Meta field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Tx) GetMetaOk() (*map[string]interface{}, bool) {
	if o == nil || o.Meta == nil {
		return nil, false
	}
	return o.Meta, true
}

// HasMeta returns a boolean if a field has been set.
func (o *Tx) HasMeta() bool {
	if o != nil && o.Meta != nil {
		return true
	}

	return false
}

// SetMeta gets a reference to the given map[string]interface{} and assigns it to the Meta field.
func (o *Tx) SetMeta(v map[string]interface{}) {
	o.Meta = &v
}

// GetBlockNumber returns the BlockNumber field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Tx) GetBlockNumber() int32 {
	if o == nil || o.BlockNumber.Get() == nil {
		var ret int32
		return ret
	}
	return *o.BlockNumber.Get()
}

// GetBlockNumberOk returns a tuple with the BlockNumber field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Tx) GetBlockNumberOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return o.BlockNumber.Get(), o.BlockNumber.IsSet()
}

// HasBlockNumber returns a boolean if a field has been set.
func (o *Tx) HasBlockNumber() bool {
	if o != nil && o.BlockNumber.IsSet() {
		return true
	}

	return false
}

// SetBlockNumber gets a reference to the given NullableInt32 and assigns it to the BlockNumber field.
func (o *Tx) SetBlockNumber(v int32) {
	o.BlockNumber.Set(&v)
}

// SetBlockNumberNil sets the value for BlockNumber to be an explicit nil
func (o *Tx) SetBlockNumberNil() {
	o.BlockNumber.Set(nil)
}

// UnsetBlockNumber ensures that no value is present for BlockNumber, not even an explicit nil
func (o *Tx) UnsetBlockNumber() {
	o.BlockNumber.Unset()
}

// GetConfirmations returns the Confirmations field value if set, zero value otherwise.
func (o *Tx) GetConfirmations() int32 {
	if o == nil || o.Confirmations == nil {
		var ret int32
		return ret
	}
	return *o.Confirmations
}

// GetConfirmationsOk returns a tuple with the Confirmations field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Tx) GetConfirmationsOk() (*int32, bool) {
	if o == nil || o.Confirmations == nil {
		return nil, false
	}
	return o.Confirmations, true
}

// HasConfirmations returns a boolean if a field has been set.
func (o *Tx) HasConfirmations() bool {
	if o != nil && o.Confirmations != nil {
		return true
	}

	return false
}

// SetConfirmations gets a reference to the given int32 and assigns it to the Confirmations field.
func (o *Tx) SetConfirmations(v int32) {
	o.Confirmations = &v
}

// GetEvents returns the Events field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Tx) GetEvents() []Event {
	if o == nil {
		var ret []Event
		return ret
	}
	return o.Events
}

// GetEventsOk returns a tuple with the Events field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Tx) GetEventsOk() (*[]Event, bool) {
	if o == nil || o.Events == nil {
		return nil, false
	}
	return &o.Events, true
}

// HasEvents returns a boolean if a field has been set.
func (o *Tx) HasEvents() bool {
	if o != nil && o.Events != nil {
		return true
	}

	return false
}

// SetEvents gets a reference to the given []Event and assigns it to the Events field.
func (o *Tx) SetEvents(v []Event) {
	o.Events = v
}

// GetAssets returns the Assets field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Tx) GetAssets() []string {
	if o == nil {
		var ret []string
		return ret
	}
	return o.Assets
}

// GetAssetsOk returns a tuple with the Assets field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Tx) GetAssetsOk() (*[]string, bool) {
	if o == nil || o.Assets == nil {
		return nil, false
	}
	return &o.Assets, true
}

// HasAssets returns a boolean if a field has been set.
func (o *Tx) HasAssets() bool {
	if o != nil && o.Assets != nil {
		return true
	}

	return false
}

// SetAssets gets a reference to the given []string and assigns it to the Assets field.
func (o *Tx) SetAssets(v []string) {
	o.Assets = v
}

// GetNonce returns the Nonce field value if set, zero value otherwise.
func (o *Tx) GetNonce() int32 {
	if o == nil || o.Nonce == nil {
		var ret int32
		return ret
	}
	return *o.Nonce
}

// GetNonceOk returns a tuple with the Nonce field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Tx) GetNonceOk() (*int32, bool) {
	if o == nil || o.Nonce == nil {
		return nil, false
	}
	return o.Nonce, true
}

// HasNonce returns a boolean if a field has been set.
func (o *Tx) HasNonce() bool {
	if o != nil && o.Nonce != nil {
		return true
	}

	return false
}

// SetNonce gets a reference to the given int32 and assigns it to the Nonce field.
func (o *Tx) SetNonce(v int32) {
	o.Nonce = &v
}

func (o Tx) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Id != nil {
		toSerialize["id"] = o.Id
	}
	if o.BlockId.IsSet() {
		toSerialize["block_id"] = o.BlockId.Get()
	}
	if o.Date != nil {
		toSerialize["date"] = o.Date
	}
	if o.Status != nil {
		toSerialize["status"] = o.Status
	}
	if o.NumEvents != nil {
		toSerialize["num_events"] = o.NumEvents
	}
	if o.Meta != nil {
		toSerialize["meta"] = o.Meta
	}
	if o.BlockNumber.IsSet() {
		toSerialize["block_number"] = o.BlockNumber.Get()
	}
	if o.Confirmations != nil {
		toSerialize["confirmations"] = o.Confirmations
	}
	if o.Events != nil {
		toSerialize["events"] = o.Events
	}
	if o.Assets != nil {
		toSerialize["assets"] = o.Assets
	}
	if o.Nonce != nil {
		toSerialize["nonce"] = o.Nonce
	}
	return json.Marshal(toSerialize)
}

type NullableTx struct {
	value *Tx
	isSet bool
}

func (v NullableTx) Get() *Tx {
	return v.value
}

func (v *NullableTx) Set(val *Tx) {
	v.value = val
	v.isSet = true
}

func (v NullableTx) IsSet() bool {
	return v.isSet
}

func (v *NullableTx) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTx(val *Tx) *NullableTx {
	return &NullableTx{value: val, isSet: true}
}

func (v NullableTx) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTx) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
